!=========================================================================
! Copyright (C) GemTalk Systems 1986-2013.  All Rights Reserved.
!
! $Id: winadmin.gs,v 1.7 2008-01-09 19:02:37 stever Exp $
!
! Superclass Hierarchy:
!   Geode, Object.
!
!=========================================================================

expectvalue %String
run
  Object _newKernelSubclass: 'Geode'
    instVarNames: #()
    classVars: #()
    classInstVars: #()
    poolDictionaries: #[]
    inDictionary: Globals
    constraints: #()
    instancesInvariant: false
    isModifiable: true "leave it modifiable"
    reservedOop: 1445 .
  (Globals at: #Geode) disallowSubclasses .
  ^ (Globals at: #Geode) definition
%

! if this is a stubbed class, remove all of its behavior and put in
! the current stub methods
expectvalue %Boolean
run
((Geode class includesSelector: #isStubbed) not
            _or: [ Geode isStubbed == true ]) ifTrue: [
  #[Geode, Geode class] do: [:each | 
    each.categories removeAll .
    each.methodDict removeAll .
  ].
  (Geode class compileMethod: 
'isAvailable
   "Returns false in this stubbed version of the class."
   ^false' 
    dictionaries: (SymbolList new) category: #Queries
   ) ~~ nil ifTrue:[^ 'compilation error'] .

  (Geode class compileMethod: 
   'isStubbed
     "Returns true in this stubbed version of the class."
     ^true' 
        dictionaries: (SymbolList new) category: #Queries
   ) ~~ nil ifTrue:[ ^ 'compilation error 2' ].
  ^ true
]
ifFalse:[^ false "Geode not stubbed, we are converting a GeODE repository"]
%

category: 'For Documentation Installation only'
classmethod: Geode
installDocumentation

| doc |
doc := GsClassDocumentation _newForObsoletePrivateGsClass: self
                            asOfGsVersion: '5.0'.

doc documentClassWith: (GsDocText new).

self description: doc.
%

